DROP VIEW PPSNEPL.EPL_COPAY_TIER_3_PRODUCTS;

CREATE OR REPLACE FORCE VIEW PPSNEPL.EPL_COPAY_TIER_3_PRODUCTS
(
    EPL_ID
    ,INACTIVATION_DATE
    ,TIER_LEVEL
    ,EFFECTIVE_DATE
    ,END_DATE
    ,GCN_SEQNO
    ,VA_PRODUCT_NAME
    ,OI_NAME
    ,PARENT_ID
    ,FUTURE_TIER
)
AS
    SELECT DISTINCT 
        PRDS.EPL_ID
        ,PRDS.INACTIVATION_DATE
        ,CURRENT_COPAY_TIER.TIER_LEVEL
        ,ASSOCS.EFFECTIVE_DATE
        ,ASSOCS.END_DATE
        ,PRDS.GCN_SEQNO
        ,PRDS.VA_PRODUCT_NAME
        ,OI.OI_NAME
        ,OI.EPL_ID AS PARENT_ID
        ,FUTURE_TIER.FUTURE_TIER_LEVEL AS PPSN_FUTURE_TIER
    FROM PPSNEPL.EPL_PROD_COPAY_TIER_ASSOCS ASSOCS
    INNER JOIN PPSNEPL.EPL_COPAY_TIER CURRENT_COPAY_TIER
        ON ASSOCS.EPL_ID_COPAY_TIER_FK = CURRENT_COPAY_TIER.EPL_ID
    INNER JOIN PPSNEPL.EPL_PRODUCTS PRDS
        ON ASSOCS.EPL_ID_PRODUCT_FK = PRDS.EPL_ID
    LEFT JOIN PPSNEPL.EPL_ORDERABLE_ITEMS OI
        ON PRDS.EPL_ID_OI_FK = OI.EPL_ID
    LEFT JOIN
    (  
        SELECT 
            FUTURE_ASSOCS.EPL_ID_PRODUCT_FK
            ,FUTURE_COPAY_TIER.TIER_LEVEL AS FUTURE_TIER_LEVEL
            ,FUTURE_ASSOCS.EFFECTIVE_DATE
        FROM PPSNEPL.EPL_PROD_COPAY_TIER_ASSOCS FUTURE_ASSOCS
        INNER JOIN PPSNEPL.EPL_COPAY_TIER FUTURE_COPAY_TIER
            ON FUTURE_ASSOCS.EPL_ID_COPAY_TIER_FK = FUTURE_COPAY_TIER.EPL_ID
        WHERE 
            FUTURE_ASSOCS.EFFECTIVE_DATE > CURRENT_DATE
    ) FUTURE_TIER
    ON FUTURE_TIER.EPL_ID_PRODUCT_FK = PRDS.EPL_ID
    WHERE
        ASSOCS.EFFECTIVE_DATE <= CURRENT_DATE
        AND (
            ASSOCS.END_DATE IS NULL
            OR ASSOCS.END_DATE >= CURRENT_DATE
        )
        AND TIER_LEVEL = '3';

GRANT SELECT ON PPSNEPL.EPL_COPAY_TIER_3_PRODUCTS TO PPSNEPL_READ_ONLY_ROLE; 
GRANT SELECT ON PPSNEPL.EPL_COPAY_TIER_3_PRODUCTS TO PPSN_ROLE;
