
DROP USER SDS CASCADE;

CREATE USER SDS
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE S_DATA_01
  TEMPORARY TABLESPACE TEMP
  PROFILE SERVICE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 3 Roles for SDS 
  GRANT CONNECT TO SDS;
  GRANT RESOURCE TO SDS;
  ALTER USER SDS DEFAULT ROLE ALL;
  -- 1 System Privilege for SDS 
  GRANT UNLIMITED TABLESPACE TO SDS;
  -- 2 Tablespace Quotas for SDS 
  ALTER USER SDS QUOTA UNLIMITED ON S_DATA_01;
  ALTER USER SDS QUOTA UNLIMITED ON S_INDEX_01;

DROP USER DATUP CASCADE;

CREATE USER DATUP
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE DATUP_DATA
  TEMPORARY TABLESPACE TEMP
  PROFILE SERVICE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 4 System Privileges for DATUP 
  GRANT CREATE ANY SEQUENCE TO DATUP;
  GRANT CREATE ANY TABLE TO DATUP;
  GRANT CREATE ANY TRIGGER TO DATUP;
  GRANT CREATE SESSION TO DATUP;
  -- 2 Tablespace Quotas for DATUP 
  ALTER USER DATUP QUOTA UNLIMITED ON DATUP_DATA;
  ALTER USER DATUP QUOTA UNLIMITED ON DATUP_INDEX;

DROP USER DATUP_APP_USER CASCADE;   

CREATE USER DATUP_APP_USER 
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE DATUP_DATA 
  TEMPORARY TABLESPACE TEMP 
  PROFILE SERVICE_ACCOUNT 
  ACCOUNT UNLOCK; 
  -- 1 System Privilege for DATUP_APP_USER 
  GRANT CREATE SESSION TO DATUP_APP_USER; 
  -- 2 Tablespace Quotas for DATUP_APP_USER 
  ALTER USER DATUP_APP_USER QUOTA UNLIMITED ON DATUP_DATA; 
  ALTER USER DATUP_APP_USER QUOTA UNLIMITED ON DATUP_INDEX; 
  -- 3 Object Privileges for DATUP_APP_USER 
    GRANT DELETE, INSERT, SELECT, UPDATE ON DATUP.FDB_SITE_UPDATE TO DATUP_APP_USER; 
    GRANT DELETE, INSERT, SELECT, UPDATE ON DATUP.FDB_VERSION TO DATUP_APP_USER; 
    GRANT DELETE, INSERT, SELECT, UPDATE ON DATUP.SITE TO DATUP_APP_USER;

DROP USER FDB_DIF CASCADE;

CREATE USER FDB_DIF
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE FDB_DATA
  TEMPORARY TABLESPACE TEMP
  PROFILE SERVICE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 4 Roles for FDB_DIF 
  GRANT CONNECT TO FDB_DIF;
  GRANT DBA TO FDB_DIF;
  GRANT RESOURCE TO FDB_DIF;
  GRANT SELECT_CATALOG_ROLE TO FDB_DIF;
  ALTER USER FDB_DIF DEFAULT ROLE ALL;
  -- 2 System Privileges for FDB_DIF 
  GRANT CREATE SESSION TO FDB_DIF;
  GRANT UNLIMITED TABLESPACE TO FDB_DIF;
  -- 2 Tablespace Quotas for FDB_DIF 
  ALTER USER FDB_DIF QUOTA UNLIMITED ON FDB_DATA;
  ALTER USER FDB_DIF QUOTA UNLIMITED ON FDB_DATA;


DROP USER FDB_DIF_APP_USER CASCADE;

CREATE USER FDB_DIF_APP_USER
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE FDB_DATA
  TEMPORARY TABLESPACE TEMP
  PROFILE SERVICE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 2 Roles for FDB_DIF_APP_USER 
  GRANT CONNECT TO FDB_DIF_APP_USER;
  GRANT FDB_DIF_READ_ONLY_ROLE TO FDB_DIF_APP_USER;
  ALTER USER FDB_DIF_APP_USER DEFAULT ROLE ALL;
  -- 1 Tablespace Quota for FDB_DIF_APP_USER 
  ALTER USER FDB_DIF_APP_USER QUOTA UNLIMITED ON FDB_DATA;


DROP USER FDB_DIF_UPDATE_USER CASCADE;

CREATE USER FDB_DIF_UPDATE_USER
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE FDB_DATA
  TEMPORARY TABLESPACE TEMP
  PROFILE SERVICE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 2 Roles for FDB_DIF_UPDATE_USER 
  GRANT CONNECT TO FDB_DIF_UPDATE_USER;
  GRANT FDB_DIF_UPDATE_USER_ROLE TO FDB_DIF_UPDATE_USER;
  ALTER USER FDB_DIF_UPDATE_USER DEFAULT ROLE ALL;
  -- 1 Tablespace Quota for FDB_DIF_UPDATE_USER 
  ALTER USER FDB_DIF_UPDATE_USER QUOTA UNLIMITED ON FDB_DATA;
  ALTER USER FDB_DIF_UPDATE_USER QUOTA UNLIMITED ON FDB_INDEX;


DROP USER KAAJEE CASCADE;

CREATE USER KAAJEE
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE KAAJEE_DATA
  TEMPORARY TABLESPACE TEMP
  PROFILE SERVICE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 3 Roles for KAAJEE 
  GRANT CONNECT TO KAAJEE;
  GRANT DBA TO KAAJEE;
  GRANT RESOURCE TO KAAJEE;
  ALTER USER KAAJEE DEFAULT ROLE ALL;
  -- 2 System Privileges for KAAJEE 
  GRANT CREATE SESSION TO KAAJEE;
  GRANT UNLIMITED TABLESPACE TO KAAJEE;
  -- 1 Tablespace Quota for KAAJEE 
  ALTER USER KAAJEE QUOTA UNLIMITED ON KAAJEE_DATA;
    
DROP USER KAAJEE_UPDATE_USER CASCADE;

CREATE USER KAAJEE_UPDATE_USER
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE KAAJEE_DATA
  TEMPORARY TABLESPACE TEMP
  PROFILE KAAJEE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 2 Roles for KAAJEE_UPDATE_USER 
  GRANT CONNECT TO KAAJEE_UPDATE_USER;
  GRANT KAAJEE_UPDATE_USER_ROLE TO KAAJEE_UPDATE_USER;
  ALTER USER KAAJEE_UPDATE_USER DEFAULT ROLE ALL;
  -- 1 System Privilege for KAAJEE_UPDATE_USER 
  GRANT CREATE SESSION TO KAAJEE_UPDATE_USER;
  -- 1 Tablespace Quota for KAAJEE_UPDATE_USER 
  ALTER USER KAAJEE_UPDATE_USER QUOTA UNLIMITED ON KAAJEE_DATA;


DROP USER PPSNEPL CASCADE;

CREATE USER PPSNEPL
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE PPSNEPL_DATA
  TEMPORARY TABLESPACE TEMP
  PROFILE SERVICE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 1 Role for PPSNEPL 
  GRANT PPSN_ROLE TO PPSNEPL;
  ALTER USER PPSNEPL DEFAULT ROLE ALL;
  -- 1 System Privilege for PPSNEPL 
  GRANT UNLIMITED TABLESPACE TO PPSNEPL;
  -- 2 Tablespace Quotas for PPSNEPL 
  ALTER USER PPSNEPL QUOTA UNLIMITED ON PPSNEPL_DATA;
  ALTER USER PPSNEPL QUOTA UNLIMITED ON USERS;

DROP USER PPSNEPL_READ_ONLY CASCADE;

CREATE USER PPSNEPL_READ_ONLY
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE PPSNEPL_DATA
  TEMPORARY TABLESPACE TEMP
  PROFILE SERVICE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 2 Roles for PPSNEPL_READ_ONLY 
  GRANT CONNECT TO PPSNEPL_READ_ONLY;
  GRANT PPSNEPL_READ_ONLY_ROLE TO PPSNEPL_READ_ONLY;
  ALTER USER PPSNEPL_READ_ONLY DEFAULT ROLE ALL;
  -- 1 System Privilege for PPSNEPL_READ_ONLY 
  GRANT UNLIMITED TABLESPACE TO PPSNEPL_READ_ONLY;


DROP USER PPSNEPL_UPDATE_USER CASCADE;

CREATE USER PPSNEPL_UPDATE_USER
  IDENTIFIED BY "<PASSWORD_HERE>"
  DEFAULT TABLESPACE PPSNEPL_DATA
  TEMPORARY TABLESPACE TEMP
  PROFILE SERVICE_ACCOUNT
  ACCOUNT UNLOCK;
  -- 3 Roles for PPSNEPL_UPDATE_USER 
  GRANT CONNECT TO PPSNEPL_UPDATE_USER;
  GRANT PPSNEPL_READ_ONLY_ROLE TO PPSNEPL_UPDATE_USER;
  GRANT PPSNEPL_UPDATE_ROLE TO PPSNEPL_UPDATE_USER;
  GRANT FDB_DIF_READ_ONLY_ROLE TO PPSNEPL_UPDATE_USER;
  GRANT FDB_DIF_UPDATE_USER_ROLE TO PPSNEPL_UPDATE_USER;
  ALTER USER PPSNEPL_UPDATE_USER DEFAULT ROLE ALL;
  -- 1 System Privilege for PPSNEPL_UPDATE_USER 
  GRANT UNLIMITED TABLESPACE TO PPSNEPL_UPDATE_USER;
  -- 1 Tablespace Quota for PPSNEPL_UPDATE_USER 
  ALTER USER PPSNEPL_UPDATE_USER QUOTA UNLIMITED ON PPSNEPL_DATA;
