#!/bin/bash
SCRIPT=$0
SCRIPT_NAME=$(basename "${SCRIPT}")
LOG_FILE=/tmp/${SCRIPT_NAME}.log
exec > >(tee -a ${LOG_FILE} )
exec 2> >(tee -a ${LOG_FILE} >&2)
LOG_TIME=`date "+%Y-%m-%d %H:%M:%S"`

echo starting ${SCRIPT_NAME} at ${LOG_TIME} 

[ "`id -u`" = "0" ] || (echo "$0 must be run as root" && exit 1)

# Fail immediately on any error
set -e

#Common dir is one level above where this script lives, and allows us to find the other peer folders
export COMMON_DIR=$(dirname "${SCRIPT}")/..
export EXT_FILE_DIR=$COMMON_DIR/external-files
export FILES_TO_COPY_DIR=$COMMON_DIR/files-to-copy-oracle
export SCRIPTS_DIR=$COMMON_DIR/scripts

echo "Doing Post DB Create Root Stuff..."	
echo "Setting up auto start and stop"	
cp $FILES_TO_COPY_DIR/dbora /etc/init.d
chmod 750 /etc/init.d/dbora
chkconfig --add dbora
sed -i -e "s;^PPSDEVGFE:/u01/dbs/oracle/.*:N$;PPSDEVGFE:/u01/dbs/oracle/.*:Y;" /etc/oratab

echo "End of ${SCRIPT_NAME}"

