#!/bin/bash
SCRIPT=$0
SCRIPT_NAME=$(basename "${SCRIPT}")
LOG_FILE=/tmp/${SCRIPT_NAME}.log
exec > >(tee -a ${LOG_FILE} )
exec 2> >(tee -a ${LOG_FILE} >&2)
LOG_TIME=`date "+%Y-%m-%d %H:%M:%S"`

echo starting ${SCRIPT_NAME} at ${LOG_TIME}

[ "`id -u -n`" = "oracle" ] || (echo "$0 must be run as oracle" && exit 1)

# Fail immediately on any error
set -e

cd /vagrant/PS_PPS_DataMgmt/src/main/resources/PPSN3.0/DDL/migration_scripts

#The following will upgrade expdp_PPSDEV05_FULL_20170213.dmp to the latest as of 4/11/2017.  
#If you use expdp_PPSDEV05_FULL_20170309.dmp, then none of these scripts are needed.
#Formulary Designator
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @PPSNEPL_CREATE_EPL_FORMULARY_DESIGNATOR_TABLE-RTC464769
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @PPSNEPL_ALTER_TABLE_EPL_PRODUCTS-RTC464769
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @PPSNEPL_ALTER_TABLE_EPL_ORDERABLE_ITEMS-RTC464769
# Rematch schema changes.
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @PPSNEPL_CREATE_EPL_REMATCH_ARTIFACTS-RTC495188
# SSOi retrofit changes
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @PPSN13_Alter_EPL_USERS_Table
# RxNorm changes
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @PPSNEPL_RX_NORM_REARCHITECT_WITH_CODING_SYSTEM-RTC514959

cd /vagrant/PS_PPS_DataMgmt/src/main/resources/PPSN3.0/Data
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @PPSNEPL_EPL_NATIONAL_SETTINGS_REPORT_MESSAGES-RTC363924
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @PPSNEPL_EPL_NATIONAL_SETTINGS_UPDATE_FD_REPORT_VERBIAGE_RTC_488485
# Re-populate rematch data after schema changes above.
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @PPSNEPL_INSERT_EPL_MATCH_TYPE-RTC495188

# Temporary until we get a new database snapshot.
cd /vagrant/PS_PPS_Dev/vagrant/scripts
echo exit | $ORACLE_HOME/bin/sqlplus / as sysdba @temp_update_pbm_users

echo "End of ${SCRIPT_NAME}"
