

package gov.va.med.pharmacy.peps.common.vo;


import java.util.List;

/**
 * Used to pass rematch information between the controller and the views. This class does not represent an individual
 * rematch.
 */
@Deprecated // Being replaced by EditRematchBean
public class DeprecatedRematchVo extends ValueObject {

    private static final long serialVersionUID = 1L;
    private MatchReason matchType;
    private boolean matchTypeFuture;
    List<UnmatchRematchVo> unmatchedList;
    List<UnmatchRematchVo> productList;
    List<UnmatchRematchVo> rematchList;
    private Match chosenMatch;
    String tableId;
    String productId;

    /**
     * Returns the reason for the rematch(es).
     */
    public MatchReason getMatchType() {

        return matchType;
    }

    public void setMatchType(MatchReason matchType) {
        if(matchType.equals(MatchReason.FUTURE_INACTIVATION)){
            matchTypeFuture = true;
        }
        else{
            matchTypeFuture = false;
        }
        this.matchType = matchType;
    }


    /**
     * Returns true if the match type is a future inactivation, false otherwise.
     * 
     * @return see method description
     */
    public boolean isMatchTypeFuture() {

        return matchTypeFuture;
    }

    public Match getChosenMatch() {

        return chosenMatch;
    }

    public void setChosenMatch(Match chosenMatch) {

        this.chosenMatch = chosenMatch;
    }

    /**
     * Returns the list of rematches that can be performed.
     */
    public List<UnmatchRematchVo> getUnmatchedList() {

        return unmatchedList;
    }

    /**
     * See {@link #getUnmatchedList()} method.
     */
    public void setUnmatchedList(List<UnmatchRematchVo> unmatchedList) {

        this.unmatchedList = unmatchedList;
    }

    /**
     * Returns the list of possible rematches provided to {@link #setRematchList(List)}.
     */
    public List<UnmatchRematchVo> getRematchList() {

        return rematchList;
    }

    /**
     * Set the list of possible rematches.
     * @param rematchList the list of possible rematches. Stores this reference, does not copy the list.
     */
    public void setRematchList(List<UnmatchRematchVo> rematchList) {

        this.rematchList = rematchList;
    }

    public List<UnmatchRematchVo> getProductList() {

        return productList;
    }

    public void setProductList(List<UnmatchRematchVo> productList) {

        this.productList = productList;
    }

    public String getTableId() {

        return tableId;
    }

    public void setTableId(String tableId) {

        this.tableId = tableId;
    }

    public String getProductId() {

        return productId;
    }

    public void setProductId(String productId) {

        this.productId = productId;
    }

    public void clearAll() {

        unmatchedList.clear();
        productList.clear();
        rematchList.clear();
        chosenMatch = null;
        tableId = null;
        productId = null;

    }

}
