package gov.va.med.pharmacy.peps.common.vo;

/**
 * Class that is the parent of all Vos that are considered main entities of the application, not Domain Data elements. As of
 * 3.0, the Entities are Orderable Item, NDC, and Product.
 *
 */
public abstract class ManagedEntityVo extends ManagedItemVo {

    private static final long serialVersionUID = -7551457384977942666L;

    /**
     * Boolean indicator if the managed item has a proposed inactivation date.
     * 
     * @return true if there is a proposed inactivation date; false for no inavtivation date
     */
    public boolean hasProposedInactivationDate() {
        if (getVaDataFields().getDataField(FieldKey.PROPOSED_INACTIVATION_DATE) != null
                && getVaDataFields().getDataField(FieldKey.PROPOSED_INACTIVATION_DATE).getValue() != null) {
            return true;
        } else {
            return false;
        }
    }

}
