

package gov.va.med.pharmacy.peps.common.vo;

/**
 * Represents a match from one product to another.
 * @deprecated to be removed under Story 452145
 */
@Deprecated
public class Match {

    private Long productId;
    private boolean auto;


    
    public Match() {

    }
    public Match(Long productId, boolean auto) {

        super();
        this.productId = productId;
        this.auto = auto;
    }

    /**
     * @return the auto
     */
    public boolean isAuto() {

        return auto;
    }

    /**
     * @param auto the auto to set
     */
    public void setAuto(boolean auto) {

        this.auto = auto;
    }

    /**
     * @return the id
     */
    public Long getProductId() {

        return productId;
    }

    /**
     * 
     * @param productId
     */
    public void setProductId(Long productId) {

        this.productId = productId;
    }

    
  /**
   * Sets the matched product for an automatic rematch. After calling this method {@link #isAuto()} will return true and
   * {@link #getProductId()} will return the matched product id. This method exists because of Spring data binding
   * limitations that prevent multiple parameters being passed in.
   * 
   * @param autoMatch the id for the matched product
   */
  public void setAutoMatch(Long autoMatch) {

    this.auto = true;
    productId = autoMatch;
  }

  /**
   * Returns the matched product id if the match type is automatic, otherwise returns null.
   * 
   * @return refer to description
   */
  public Long getAutoMatch() {
    if (auto) {
      return productId;
    }
    return null;
  }
    
  /**
   * Sets the matched product for a suggested rematch. After calling this method {@link #isAuto()} will return false and
   * {@link #getProductId()} will return the matched product id. This method exists because of Spring data binding
   * limitations that prevent multiple parameters being passed in.
   * 
   * @param suggestedMatch the id for the matched product
   */
  public void setSuggestedMatch(Long suggestedMatch) {

    this.auto = false;
    productId = suggestedMatch;
  }

  /**
   * Returns the matched product id if the match type is suggested, otherwise returns null.
   * 
   * @return refer to description
   */
  public Long getSuggestedMatch() {
    if (!auto) {
      return productId;
    }
    return null;
  }
}
