/**
 * Source file created in 2011 by Southwest Research Institute
 */


package gov.va.med.pharmacy.peps.common.vo;


/**
 * Enumerates all of the available National Settings.
 */
public enum NationalSetting {
    
    /** CURRENT_VUID */
    CURRENT_VUID,
    
    /** MAX_VUID */
    MAX_VUID,
    
    /** FDB_ADD */
    FDB_ADD_LAST_RUN,
    
    /** FSS_UPDATE */
    FDB_UPDATE_LAST_RUN,
    
    /** STS_UPDATE */ 
    STS_UPDATE_LAST_RUN,
    
    /** FSS_UPDATE */
    FSS_UPDATE_LAST_RUN,
    
    /** INACTIVATION_CHECK_LAST_RUN */
    INACTIVATION_CHECK_LAST_RUN,
    
    /** NDF_UPDATE */
    NDF_UPDATE_LAST_RUN,
    
    /** RXNORM_UPDATE */
    RXNORM_UPDATE_LAST_RUN,
   
    /** NDF_OUTGOING_FILE_TEXT */
    NDF_OUTGOING_FILE_TEXT,
    
    /** NDF_OUTPUT_FILE_DIRECOTRY */
    NDF_OUTPUT_FILE_DIRECTORY,
    
    /** NDF_OUTPUT_PROD_PROTOCOL */
    NDF_OUTPUT_PROD_PROTOCOL,
    
    /** NDF_OUTPUT_PROD_HOSTNAME */
    NDF_OUTPUT_PROD_HOSTNAME,
    
    /** NDF_OUTPUT_PROD_PORT */
    NDF_OUTPUT_PROD_PORT,
    
    /** NDF_OUTPUT_PROD_USERNAME */
    NDF_OUTPUT_PROD_USERNAME,
    
    /** NDF_OUTPUT_PROD_PASSWORD */
    NDF_OUTPUT_PROD_PASSWORD,
    
    /** NDF_OUTPUT_PROD_DIRECTORY */
    NDF_OUTPUT_PROD_DIRECTORY,
    
    /** NDF_OUTPUT_TST_PORT */
    NDF_OUTPUT_TST_PORT,
    
    /** NDF_OUTPUT_TST_PROTOCOL */
    NDF_OUTPUT_TST_PROTOCOL,
    
    /** NDF_OUTPUT_TST_HOSTNAME */
    NDF_OUTPUT_TST_HOSTNAME,
    
    /** NDF_OUTPUT_TST_USERNAME */
    NDF_OUTPUT_TST_USERNAME,
    
    /** NDF_OUTPUT_TST_PASSWORD */
    NDF_OUTPUT_TST_PASSWORD,
    
    /** NDF_OUTPUT_TST_DIRECTORY */
    NDF_OUTPUT_TST_DIRECTORY,
    
    /** NDF_OUTPUT_TST_REJECTED_DIRECTORY */
    NDF_OUTPUT_TST_REJECTED_DIRECTORY,
    
    /** NDF_OUTPUT_TST_REJECTED_HOSTNAME */
    NDF_OUTPUT_TST_REJECTED_HOSTNAME, 
    
    /** NDF_OUTPUT_TST_REJECTED_PASSWORD */
    NDF_OUTPUT_TST_REJECTED_PASSWORD,
    
    /** NDF_OUTPUT_TST_REJECTED_PORT */
    NDF_OUTPUT_TST_REJECTED_PORT,
    
    /** NDF_OUTPUT_TST_REJECTED_USERNAME */
    NDF_OUTPUT_TST_REJECTED_USERNAME,
    
    /** FDB_ADD_RUN_STATE */
    FDB_ADD_RUN_STATE,
    
    /** FDB_UPDATE_RUN_STATE */
    FDB_UPDATE_RUN_STATE,
    
    /** STS_RUN_STATE */
    STS_RUN_STATE,
    
    /** FSS_RUN_STATE */
    FSS_RUN_STATE,
    
    /** INACTIVATION_RUN_STATE */
    INACTIVATION_RUN_STATE,
    
    /** NDF_UPDATE_RUN_STATE */
    NDF_UPDATE_RUN_STATE,
    
    /** RXNORM_UPDATE_RUN_STATE */
    RXNORM_UPDATE_RUN_STATE,
 
    /** HOST_NAME */
    HOST_NAME,
    
    /**
     * MESSAGE_STATUS. Was used for the v1.x direct send to VistA functionality and should probably be removed.
     */
    MESSAGE_STATUS,
    
    /** MESSAGE_ERROR */
    MESSAGE_ERROR,
    
    /** NUM_MSG_QUEUE */
    NUM_MSG_QUEUE,
    
    /**
     * MESSAGE_QUEUE_IN_PROGRESS. Was used for the v1.x direct send to VistA functionality and should probably be
     * removed.
     */
    MESSAGE_QUEUE_IN_PROGRESS,
    
    /** REPORT_CAPTURE_START */    
    REPORT_CAPTURE_START,
    
    /** REPORT_CAPTURE_COMPLETE */
    REPORT_CAPTURE_COMPLETE,
    
    /** REPORT_INGREDIENT_START */
    REPORT_INGREDIENT_START,
    
    /** REPORT_INGREDIENT_COMPLETE */
    REPORT_INGREDIENT_COMPLETE,
    
    /** REPORT_WARNING_START */
    REPORT_WARNING_START,
    
    /** REPORT_WARNING_COMPLETE */
    REPORT_WARNING_COMPLETE,

    /**
     * Setting which indicates when generation of the most recent 
     * 'Products with Copay Tier Change Data' report was started.
     */
    REPORT_COPAY_TIER_CHANGE_START,
    
    /**
     * Setting which indicates when generation of the most recent 
     * 'Products with Copay Tier Change Data' report was completed.
     */
    REPORT_COPAY_TIER_CHANGE_COMPLETE,
    
    /**
     * Setting which indicates when generation of the most recent 
     * 'FDB Copay Change' report was started.
     */
    REPORT_FDB_COPAY_CHANGE_START,
    
    /**
     * Setting which indicates when generation of the most recent 
     * 'FDB Copay Change' report was completed.
     */
    REPORT_FDB_COPAY_CHANGE_COMPLETE,
    
    /** REPORT_COMPLIANCE_START */
    REPORT_DATA_UPDATE_START,
    
    /** REPORT_COMPLIANCE_COMPLETE */
    REPORT_DATA_UPDATE_COMPLETE,
    
    
    /** FDB_MIGRATION_RUN_STATE */
    FDB_MIGRATION_RUN_STATE,    
    
    /** FSS_MIGRATION_RUN_STATE */
    FSS_MIGRATION_RUN_STATE,    
    
    /** FDB_MIGRATION_LAST_RUN */
    FDB_MIGRATION_LAST_RUN,
    
    /** FSS_MIGRATION_LAST_RUN */
    FSS_MIGRATION_LAST_RUN,
    
    
    /** HOME_IMG_SELECTED */
    HOME_IMG_SELECTED,
    
    /** HOME_IMG_PATH */
    HOME_IMG_PATH,
    
    /** HOME_IMG_MEDIA_TYPE */
    HOME_IMG_MEDIA_TYPE,
    
    /** HOME_ANNOUNCE_TITLE */
    HOME_ANNOUNCE_TITLE,
    
    /** HOME_ANNOUNCE_BODY */
    HOME_ANNOUNCE_BODY,
    
    /** HOME_ANNOUNCE_LINK */
    HOME_ANNOUNCE_LINK,
    
    /** HOME_ANNOUNCE_LINK_TITLE */
    HOME_ANNOUNCE_LINK_TITLE,
    
    NATIONAL_SITE_NUMBER;
    
}
