package gov.va.med.pharmacy.peps.common.vo;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * Metadata describing an NDF update file.
 */
public class NdfUpdateFileVo extends ValueObject{
    
    private static final long serialVersionUID = 1L;

    private String fileId;
    private String fileName;
    private String comments; 
    private String directoryPath;
    private Date testTransmissionDtm;
    private Date prodTransmissionDtm;
    @JsonFormat(shape=JsonFormat.Shape.STRING, pattern="yyyy-MM-dd HH:mm:ss:SSS", timezone="EST")
    private Date statusModifiedDtm;
    private StatusVo status;  
    
   public String getFileId() {
    
        return fileId;
    }
    
    public void setFileId(String fileId) {     
    
        this.fileId = fileId;
    }
    
    public String getFileName() {
    
        return fileName;
    }
    
    public void setFileName(String fileName) {
    
        this.fileName = fileName;
    }
    
    public String getComments() {
    
        return comments;
    }
    
    public void setComments(String comments) {
    
        this.comments = comments;
    }
    
    
    public String getDirectoryPath() {
    
        return directoryPath;
    }

    
    public void setDirectoryPath(String directoryPath) {
    
        this.directoryPath = directoryPath;
    }

    public Date getTestTransmissionDtm() {
    
        return testTransmissionDtm;
    }
    
    public void setTestTransmissionDtm(Date testTransmissionDtm) {
    
        this.testTransmissionDtm = testTransmissionDtm;
    }
    
    public Date getProdTransmissionDtm() {
    
        return prodTransmissionDtm;
    }
    
    public void setProdTransmissionDtm(Date prodTransmissionDtm) {
    
        this.prodTransmissionDtm = prodTransmissionDtm;
    }
    
    public Date getStatusModifiedDtm() {
    
        return statusModifiedDtm;
    }
    
    public void setStatusModifiedDtm(Date statusModifiedDtm) {
    
        this.statusModifiedDtm = statusModifiedDtm;
    }
    
    public StatusVo getStatus() {
    
        return status;
    }
    
    public void setStatus(StatusVo status) {
    
        this.status = status;
    }
    
    public String getStatusName() {
        
        return getStatus().getStatusName();
    }  
    
}
