package gov.va.med.pharmacy.peps.common.vo;

import java.math.BigDecimal;
import java.util.Date;

/**
 * Extension of ReportCopayTierChangeVo to add setters compatible with Hibernate's aliasToBean mapping to the
 * ppsCopayChangeReport query.
 */
public class ReportCopayTierChangeVoHibernate extends ReportCopayTierChangeVo {

  /**
   * Alternate setter for Hibernate to populate the EPL Id via the ppsCopayChangeReport native query.
   * 
   * @param idParam idParam
   */
  public final void setID(BigDecimal idParam) {
    //translate null to null and avoid NPE
    if (idParam != null) {
      setEplId(idParam.longValue());
    } else {
      setEplId(null);
    }
  }

  /**
   * Alternate setter for Hibernate to populate the VA product name via the ppsCopayChangeReport native query.
   * 
   * @param vaProductNameParam vaProductNameParam
   */
  public final void setVA_PRODUCT_NAME(String vaProductNameParam) {
    setVaProductName(vaProductNameParam);
  }

  /**
   * Alternate setter for Hibernate to populate the CMOP Id via the ppsCopayChangeReport native query.
   *
   * @param cmopIdParam the new cmop id
   */
  public final void setCMOP_ID(String cmopIdParam) {
    setCmopId(cmopIdParam);
  }

  /**
   * Alternate setter for Hibernate to populate the national formulary name via the ppsCopayChangeReport native query.
   *
   * @param nationalFormularyNameParam the new national formulary name
   */
  public final void setNATIONAL_FORMULARY_NAME(String nationalFormularyNameParam) {
    setNationalFormularyName(nationalFormularyNameParam);
  }

  /**
   * Alternate setter for Hibernate to populate the status date via the ppsCopayChangeReport native query.
   *
   * @param statusDateParam the new status date
   */
  public final void setSTATUS_DATE(Date statusDateParam) {
    setStatusDate(statusDateParam);
  }

  /**
   * Alternate setter for Hibernate to populate the item status via the ppsCopayChangeReport native query.
   *
   * @param itemStatusParam the new item status
   */
  public final void setITEM_STATUS(String itemStatusParam) {
    // do nothing
  }

  /**
   * Alternate setter for Hibernate to populate the copay tier the ppsCopayChangeReport native query.
   *
   * @param tierParam the new tier
   */
  public final void setTIER(String tierParam) {
    setTier(tierParam);
  }

  /**
   * Alternate setter for Hibernate to populate the copay tier effective date via the ppsCopayChangeReport native query.
   *
   * @param effectiveDateParam the new effective date
   */
  public final void setEFFECTIVE_DATE(Date effectiveDateParam) {
    setEffectiveDate(effectiveDateParam);
  }

  /**
   * Alternate setter for Hibernate to populate the copay tier end date via the ppsCopayChangeReport native query.
   *
   * @param endDateParam the new end date
   */
  public final void setEND_DATE(Date endDateParam) {
    setEndDate(endDateParam);
  }

  /**
   * Alternate setter for Hibernate to populate the future tier level via the ppsCopayChangeReport native query.
   *
   * @param futureTierLevelParam the new future tier level
   */
  public final void setFUTURE_TIER_LEVEL(String futureTierLevelParam) {
    setFutureTierLevel(futureTierLevelParam);
  }

  /**
   * Alternate setter for Hibernate to populate the future effective date via the ppsCopayChangeReport native query.
   *
   * @param futureEffectiveDateParam the new future effective date
   */
  public final void setFUTURE_EFFECTIVE_DATE(Date futureEffectiveDateParam) {
    setFutureEffectiveDate(futureEffectiveDateParam);
  }

  /**
   * Alternate setter for Hibernate to populate the drug class via the ppsCopayChangeReport native query.
   *
   * @param drugClassParam the new drug class
   */
  public final void setDRUG_CLASS(String drugClassParam) {
    setDrugClass(drugClassParam);
  }

}
