/**
 * Source file created in 2012 by Southwest Research Institute
 */


package gov.va.med.pharmacy.peps.common.utility.test;


import static org.hamcrest.CoreMatchers.notNullValue;
import static org.junit.Assert.*;

import org.junit.Test;

import gov.va.med.pharmacy.peps.common.utility.ConfigFileUtility;


/**
 * Unit tests for {@link ConfigFileUtility}.
 */
public class ConfigFileUtilityTest {

    private ConfigFileUtility cfu = new ConfigFileUtility();

    /**
     * testTimeout
     *
     */
    @Test
    public void testTimeout() {

        assertEquals("Config timeout specification", ConfigFileUtility.DEFAULT_TIMEOUT, cfu.getTimeout());
    }

    /**
     * testDivision
     *
     */
    @Test
    public void testDivision() {

        assertEquals("Config division specification", ConfigFileUtility.DEFAULT_DIVISION, cfu.getDivision());
    }

    /**
     * testProxy
     *
     */
    @Test
    public void testProxy() {

        assertEquals("Config NDFProxyUserIEN specification", ConfigFileUtility.DEFAULT_PROXY, cfu.getNdfProxyUserDUZ());
    }

    /**
     * testConnSpec
     *
     */
    @Test
    public void testConnSpec() {

        assertEquals("Config connection spec name specification", ConfigFileUtility.DEFAULT_CONNSPEC,
            cfu.getConnectionSpecName());
    }

    /**
     * testRpcTimeout
     *
     */
    @Test
    public void testRpcTimeout() {

        assertEquals("Config RPC Timeout specification", ConfigFileUtility.DEFAULT_RPCTIMEOUT, cfu.getRpcTimeout());
    }

    /**
     * testFdbLocation
     *
     */
    @Test
    public void testFdbLocation() {

        assertEquals("Config FDB Image location specification", ConfigFileUtility.DEFAULT_FDB_IMAGE_PATH,
            cfu.getFdbImageLocation());
    }

  /**
   * Tests that {@link ConfigFileUtility#getPersistentDirectory()} is not null. We can't check that it exists because it
   * will only exist when running in WebLogic.
   */
  @Test
  public void testPersistentDirectory() {
    assertThat(cfu.getPersistentDirectory(), notNullValue());
  }
}
