package gov.va.med.pharmacy.peps.common.vo.validator.fields.test;

import static org.hamcrest.CoreMatchers.equalTo;
import static org.junit.Assert.assertThat;

import org.apache.commons.lang3.RandomStringUtils;
import org.junit.Test;

import gov.va.med.pharmacy.peps.common.vo.FieldKey;
import gov.va.med.pharmacy.peps.common.vo.validator.ErrorKey;
import gov.va.med.pharmacy.peps.common.vo.validator.Errors;

/**
 * JUnit Test class for OrderableItemTextValidator.
 * @since 3.0
 */
public class OrderableItemTextValidatorTest {

  /**
   * Test method for
   * {@link gov.va.med.pharmacy.peps.common.vo.validator.fields.OrderableItemTextValidator#validate(
   * java.lang.String, gov.va.med.pharmacy.peps.common.vo.validator.Errors)}.
   * 
   */
  @Test
  public void testValidateStringErrors() {
    final int MAX_LENGTH = 255;
    // EMPTY STRING
    String testString = "";
    Errors errors = new Errors();
    FieldKey.OI_TEXT.newValidatorInstance().validate(testString, errors);
    assertThat(errors.size(), equalTo(0));

    // MAX LENGTH STRING
    testString = RandomStringUtils.random(MAX_LENGTH);
    errors = new Errors();
    FieldKey.OI_TEXT.newValidatorInstance().validate(testString, errors);
    assertThat(errors.size(), equalTo(0));

    // STRING THAT IS ONE CHARACTER TOO LONG
    testString = RandomStringUtils.random(MAX_LENGTH + 1);
    errors = new Errors();
    FieldKey.OI_TEXT.newValidatorInstance().validate(testString, errors);
    assertThat(errors.size(), equalTo(1));
    assertThat(errors.getErrors().get(0).getErrorKey(), equalTo(ErrorKey.COMMON_MAX_MIN_LENGTH));
    assertThat(errors.getErrors().get(0).getFieldKey(), equalTo(FieldKey.OI_TEXT));

  }

}
