/**
 * Source file created in 2007 by Southwest Research Institute
 */


package gov.va.med.pharmacy.peps.domain.common.capability;


import gov.va.med.pharmacy.peps.common.vo.NdcVo;
import gov.va.med.pharmacy.peps.domain.common.model.EplNdcDo;


/**
 * Perform CRUD operations on NdcVo
 */
public interface NdcDomainCapability extends ManagedItemDomainCapability<NdcVo, EplNdcDo> {

    /** 
     * ndcExists
     * @param ndcNoDashes ndcNoDashes
     * @return True if the NDC String exists in the database
     */
    boolean ndcExists(String ndcNoDashes);
    
    /** 
     * Returns the EPL ID of the specified NDC, if it exists.
     * 
     * @param ndcNoDashes the NDC code with no dashes
     * @return the ID if it exists, or 0 if it does not exist
     */
    long getIdFromNDC(String ndcNoDashes);
}
