

package gov.va.med.pharmacy.peps.domain.common.capability.impl;


import gov.va.med.pharmacy.peps.common.object.VistaStatus;
import gov.va.med.pharmacy.peps.common.vo.EplVistaUpdateVo;
import gov.va.med.pharmacy.peps.domain.common.capability.VistaUpdateCapability;
import gov.va.med.pharmacy.peps.domain.common.dao.EplVistaUpdateDao;
import gov.va.med.pharmacy.peps.domain.common.model.EplVistaStatusDo;
import gov.va.med.pharmacy.peps.domain.common.model.EplVistaUpdateDo;
import gov.va.med.pharmacy.peps.domain.common.utility.converter.EplVistaUpdateConverter;

import org.apache.logging.log4j.Logger; 
import org.apache.logging.log4j.LogManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class VistaUpdateCapabilityImpl implements VistaUpdateCapability {
    private static final Logger LOG = LogManager.getLogger(VistaUpdateCapabilityImpl.class);

    private final EplVistaUpdateDao eplVistaUpdateDao;
    
    private final EplVistaUpdateConverter vistaUpdateConverter;
    
    /**
     * Constructs an instance with the required dependencies.
     * @param pEplVistaUpdateDao The {@link EplVistaUpdateDao} to use.
     * @param pEplVistaUpdateConverter The {@link EplVistaUpdateConverter} to use.
     */
    @Autowired
    public VistaUpdateCapabilityImpl(
        final EplVistaUpdateDao pEplVistaUpdateDao, final EplVistaUpdateConverter pEplVistaUpdateConverter) {
      eplVistaUpdateDao = pEplVistaUpdateDao;
      vistaUpdateConverter = pEplVistaUpdateConverter;
    }

    @Override
    public EplVistaUpdateDo saveUpdate(EplVistaUpdateVo eplVistaUpdate) {
        LOG.debug(eplVistaUpdate.toString());     
        
        //email notification related code.
        final EplVistaUpdateDo convertedDo = vistaUpdateConverter.convert(eplVistaUpdate);
        final EplVistaUpdateDo savedDo = eplVistaUpdateDao.save(convertedDo);  
       
        // As of PPS-N 3.0 this e-mail notification has been moved to the Vista Mailman
        // vistaInstallNotification(vistaUpdateDo);
        
        return savedDo;
    }
    
    @Override
    public EplVistaStatusDo getStatus(VistaStatus vistaStatus) {
       return null;
    }

  
}
