/**
 * Source file created in 2006 by Southwest Research Institute
 */


package gov.va.med.pharmacy.peps.domain.common.dao;


import java.util.List;

import gov.va.med.pharmacy.peps.domain.common.model.EplProductDo;
import gov.va.med.pharmacy.peps.domain.common.model.dto.FutureInactiveProductDto;


/**
 * This interface provides a set of operations that may be performed on all the classes that 
 * inherit from this interface.  It provides abstract methods to access and modify the EplProductDo.
 * 
 */
public interface EplProductDao extends DataAccessObject<EplProductDo, Long> {

    public List<Object[]> retrieveInactive();
    
    public List<Object[]> retrieveGcnNdcMap();
    
    /**
     * Retrieve Product objects by NDC
     * 
     * @return list of Product objects
     */
    List<EplProductDo> retrieveVaProduct(String ndc);
    
    /**
     * Queries for products with future (proposed) inactivations.
     * @return a List in alphabetical order by VA Product Name. Never null.
     */
    public List<FutureInactiveProductDto> findFutureInactive();

    /**
     * To be used only on integration test
     * @return
     */
    public List<EplProductDo> retrieveTestProductList();
}
