package gov.va.med.pharmacy.peps.domain.common.model;


// Generated Mar 13, 2014 4:13:49 PM by Hibernate Tools 3.4.0.CR1
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.ColumnResult;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.SqlResultSetMapping;
import javax.persistence.SqlResultSetMappings;
import javax.persistence.Table;

import org.apache.commons.lang3.builder.ReflectionToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import org.hibernate.annotations.NamedNativeQueries;
import org.hibernate.annotations.NamedNativeQuery;

//TODO: Consider replacing file number and field number parameters with constants from VistaFile and children in many queries.
//See messageCMOPChangeReport as an example.  Some queries are generic and still require the parameters, like findModifiedRecords. 
/**
 * Represents an outgoing change to a single VistA field.
 */
@Entity
@NamedQueries({
    // added sort by vista_ien in 3.0 since VistA needs to see the first sub-sequence first, others may
    // be out of order (since vista_ien is varchar, it may sort 1, 10, 2, ...).
    @NamedQuery(name= "retrieveDifferencesForOutputFile",
        query="SELECT odiff FROM EplNdfOutgoingDifferences odiff " +
                "WHERE odiff.createdDtm <= :startDate AND odiff.ndcUpdateFileFk IS NULL " +
                "ORDER BY odiff.actionType, odiff.vistaFileNumber, odiff.vistaFieldNumber, odiff.vistaIen"),
                        
    @NamedQuery(name= "findByFileFieldIen",
        query="SELECT odiff FROM EplNdfOutgoingDifferences odiff " +
                "WHERE odiff.vistaFileNumber = :vistaFileNumber AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                "AND odiff.vistaIen = :vistaIen AND odiff.ndcUpdateFileFk IS NULL  " +
                "ORDER BY odiff.vistaFileNumber, odiff.vistaFieldNumber, odiff.vistaIen"),
                
    @NamedQuery(name = "findModifiedRecords",
        query = "SELECT odiff FROM EplNdfOutgoingDifferences odiff " +
            "WHERE odiff.vistaFileNumber = :vistaFileNumber AND odiff.vistaFieldNumber = :vistaFieldNumber " +
            "AND odiff.vistaIen = :vistaIen AND odiff.actionType = :actionType AND odiff.ndcUpdateFileFk IS NULL  " +
            "ORDER BY odiff.vistaFileNumber, odiff.vistaFieldNumber, odiff.vistaIen"),
    
    @NamedQuery(name= "findByFileAndField",
        query="SELECT odiff.vistaIen, odiff.newValue FROM EplNdfOutgoingDifferences odiff " +
              "WHERE odiff.vistaFileNumber = :vistaFileNumber " +
                  "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                  "AND odiff.createdDtm <= :startDate " +
                  "AND odiff.ndcUpdateFileFk IS NULL " +
                  "AND odiff.actionType = 'M' " +
              "ORDER BY odiff.vistaIen"),
            
    @NamedQuery(name="findDrugClassChanges",
       query="SELECT odiff.vistaIen, odiff.newValue, prod.eplVaGenName.ndfGenericIen FROM EplNdfOutgoingDifferences odiff, EplProductDo prod  " +
             "WHERE odiff.vistaIen = prod.ndfProductIen " +
                 "AND odiff.vistaFileNumber = :vistaFileNumber " +
                 "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                 "AND odiff.createdDtm <= :startDate " +
                 "AND odiff.ndcUpdateFileFk IS NULL " +
                 "AND odiff.actionType = 'M' " +
             "ORDER BY odiff.vistaIen"),
    
    @NamedQuery(name= "genericNameInactivateReport",
        query="SELECT odiff.vistaIen " +
              "FROM EplNdfOutgoingDifferences odiff " +
              "WHERE odiff.vistaFileNumber = :vistaFileNumber " + 
                  "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                  "AND odiff.createdDtm <= :startDate " +
                  "AND odiff.newValue <> ' ' " + 
                  "AND odiff.ndcUpdateFileFk IS NULL " +
              "ORDER BY odiff.vistaIen"),
    
    @NamedQuery(name= "overrideDFChkExclReport",
        query="SELECT odiff.newValue, p.vaProductName, p.cmopId " +
              "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
              "WHERE odiff.ndcUpdateFileFk IS NULL " +
                  "AND odiff.vistaFileNumber = :vistaFileNumber " +
                  "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                  "AND odiff.createdDtm <= :startDate " +
                  "AND odiff.vistaIen = p.ndfProductIen " +
                  "AND odiff.actionType = 'M' " +
               "ORDER BY odiff.vistaIen"),
              
    @NamedQuery(name = "activeNatFormularyChangeReport",
        query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.newValue = '1' " + 
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY odiff.vistaIen"),
            
    @NamedQuery(name = "inactiveNatFormularyChangeReport",
        query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.newValue = '0' " +
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY odiff.vistaIen"),
                
    @NamedQuery(name = "inactivatedCMOPReport",
        query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    " AND odiff.vistaFileNumber = :vistaFileNumber " +
                    " AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    " AND odiff.createdDtm <= :startDate " +
                    " AND odiff.newValue = '0' " +
                    " AND odiff.vistaIen = p.ndfProductIen " +
                    " AND odiff.actionType = 'M' " +
                "ORDER BY p.vaProductName"),
                
    @NamedQuery(name = "unmatchedProducts",
        query = "SELECT DISTINCT odiff.vistaIen, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber in ('6','5','8','3','2','.05','1') " +
                    "AND odiff.oldValue <> odiff.newValue " +
                    "AND odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY odiff.vistaIen"),
                
    @NamedQuery(name = "inactivatedProductsForLocal",
        query = "SELECT DISTINCT odiff.vistaIen, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber in ('5','2','8','.05') " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.oldValue <> odiff.newValue " +
                    "AND odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY odiff.vistaIen"),
            
    @NamedQuery(name = "scheduleChangeReport",
        query = "SELECT odiff.vistaIen, p.vaProductName, odiff.newValue " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.actionType = 'M' " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.oldValue <> odiff.newValue " +
                    "AND odiff.vistaIen = p.ndfProductIen " +                    
                "ORDER BY odiff.vistaIen"),
                
    @NamedQuery(name = "noPossibleDosageReport",
        query = "SELECT odiff.vistaFieldNumber, odiff.newValue, odiff.vistaIen, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +                    
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber in ('41','42') " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.oldValue <> odiff.newValue " +
                    "AND odiff.vistaIen = p.ndfProductIen " +                    
                    "AND p.ndfProductIen in (SELECT vistaIen FROM EplNdfOutgoingDifferences WHERE vistaFieldNumber = '40' and newValue = 'N') " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY odiff.vistaIen, p.cmopId, odiff.vistaFieldNumber"),
                
    @NamedQuery(name = "yesPossibleDosageReport",
        query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +                
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.oldValue <> odiff.newValue " +
                    "AND odiff.newValue ='Y' " +
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY p.vaProductName"),
                
    @NamedQuery(name = "printNameChangeReport",
        query = "SELECT odiff.newValue, odiff.oldValue, p.vaProductName " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.oldValue <> odiff.newValue " +                    
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY p.vaProductName"),
                
    @NamedQuery(name = "messageGenericChangeReport",
        query = "SELECT odiff.newValue, odiff.oldValue, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.oldValue <> odiff.newValue " +                    
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY p.vaProductName"),
                
    @NamedQuery(name = "findCMOPIdChanges",
        query = "SELECT odiff.newValue, odiff.oldValue, p.vaProductName, p.cmopId " +
            "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
            "WHERE odiff.ndcUpdateFileFk IS NULL " +
                " AND odiff.vistaFileNumber = :vistaFileNumber " +
                " AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                " AND odiff.createdDtm <= :startDate " +
                " AND odiff.oldValue <> odiff.newValue " +   
                " AND odiff.vistaIen = p.ndfProductIen " +
                " AND odiff.actionType = 'M' " +
            "ORDER BY p.vaProductName"),
    
    @NamedQuery(name = "addedMedGuideReport",
    query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
            "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
            "WHERE odiff.ndcUpdateFileFk IS NULL " +                
                "AND odiff.vistaFileNumber = :vistaFileNumber " +
                "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                "AND odiff.createdDtm <= :startDate " +
                "AND odiff.oldValue <> odiff.newValue " +
                "AND odiff.newValue <>' ' " +
                "AND odiff.oldValue =' ' " +
                "AND odiff.vistaIen = p.ndfProductIen " +
                "AND odiff.actionType = 'M' " +
            "ORDER BY p.vaProductName"),
    
    @NamedQuery(name = "editedMedGuideReport",
    query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
            "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
            "WHERE odiff.ndcUpdateFileFk IS NULL " +                
                "AND odiff.vistaFileNumber = :vistaFileNumber " +
                "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                "AND odiff.createdDtm <= :startDate " +
                "AND odiff.oldValue <> odiff.newValue " +
                "AND odiff.oldValue <>' ' " +
                "AND odiff.newValue <>' ' " +
                "AND odiff.vistaIen = p.ndfProductIen " +
                "AND odiff.actionType = 'M' " +
            "ORDER BY p.vaProductName"),
        
    @NamedQuery(name = "deletedMedGuideReport",
        query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.oldValue <> odiff.newValue " +
                    "AND odiff.oldValue <>' ' " +
                    "AND odiff.newValue = ' ' " +
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY p.vaProductName"),
    
    @NamedQuery(name = "excludedDDIReport",
    query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
            "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
            "WHERE odiff.ndcUpdateFileFk IS NULL " +                
                "AND odiff.vistaFileNumber = :vistaFileNumber " +
                "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                "AND odiff.createdDtm <= :startDate " +
                "AND odiff.oldValue <> odiff.newValue " +
                "AND odiff.newValue = '1' " +
                "AND odiff.vistaIen = p.ndfProductIen " +
                "AND odiff.actionType = 'M' " +
            "ORDER BY p.vaProductName"),
            
    @NamedQuery(name = "prevExcludedDDIReport",
        query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.oldValue <> odiff.newValue " +
                    "AND odiff.newValue = ' ' " +
                    "AND odiff.oldValue = '1' " +
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                "ORDER BY p.vaProductName"),
    
    @NamedQuery(name = "reactivatedProductReport",
    query = "SELECT odiff.newValue, odiff.oldValue, p.vaProductName, p.cmopId " +
            "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
            "WHERE odiff.ndcUpdateFileFk IS NULL " +
                "AND odiff.vistaFileNumber = :vistaFileNumber " +
                "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                "AND odiff.oldValue <> odiff.newValue " + 
                "AND odiff.createdDtm <= :startDate " +
                "AND odiff.oldValue <> ' ' " + 
                "AND odiff.oldValue IS NOT NULL " + 
                "AND odiff.newValue = ' ' " +
                "AND odiff.vistaIen = p.ndfProductIen " +
                "AND odiff.actionType = 'M' " +
            "ORDER BY p.vaProductName"),
            
    @NamedQuery(name = "inactivatedProductReport",
        query = "SELECT odiff.newValue, odiff.oldValue, odiff.vistaIen, p.vaProductName, p.cmopId " +
                "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.newValue <> ' ' " +
                    "AND odiff.oldValue IS NULL " +                    
                    "AND odiff.vistaIen = p.ndfProductIen " +
                    "AND odiff.actionType = 'M' " +
                    // This appears to be excluding products that also have a EplRematchDo to be sent.
                    "AND odiff.vistaIen NOT IN (SELECT rematch.fromProduct.ndfProductIen FROM EplRematchDo rematch " +
                                               "WHERE rematch.ndfUpdateFile is NULL  " +
                                               "AND rematch.createdDtm <= :startDate " +
                                               "AND rematch.matchType.matchTypeId = 1) " +
                "ORDER BY p.vaProductName"),
            
    @NamedQuery(name = "editedDDIReport",
        query = "SELECT odiff.newValue, ddi.interactionName, s.name " +
                "FROM EplNdfOutgoingDifferences odiff, EplDrugDrugInteractionDo ddi, EplDdiSeverityDo s " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.actionType = 'M' " +
                    "AND odiff.oldValue <> odiff.newValue " +
                    "AND odiff.vistaIen = ddi.vistaIen " +
                    "AND ddi.severity.severityId = s.severityId " +
                "ORDER BY ddi.interactionName"),
            
    @NamedQuery(name = "inactivatedDDIReport",
        query = "SELECT odiff.vistaIen, odiff.newValue, odiff.oldValue, ddi.interactionName, s.name " +
                "FROM EplNdfOutgoingDifferences odiff, EplDrugDrugInteractionDo ddi, EplDdiSeverityDo s " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.actionType = 'M' " +
                    "AND odiff.newValue <> ' ' " +
                    "AND odiff.oldValue IS NULL " +
                    "AND odiff.vistaIen = ddi.vistaIen " +
                    "AND ddi.severity.severityId = s.severityId " +            
                "ORDER BY ddi.interactionName"),
            
    @NamedQuery(name = "reactivatedDDIReport",
        query = "SELECT odiff.vistaIen, odiff.newValue, odiff.oldValue, ddi.interactionName, s.name " +
                "FROM EplNdfOutgoingDifferences odiff, EplDrugDrugInteractionDo ddi, EplDdiSeverityDo s " +
                "WHERE odiff.ndcUpdateFileFk IS NULL " +
                    "AND odiff.vistaFileNumber = :vistaFileNumber " +
                    "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                    "AND odiff.createdDtm <= :startDate " +
                    "AND odiff.actionType = 'M' " +
                    "AND odiff.oldValue <> odiff.newValue " +
                    "AND odiff.oldValue <> ' ' " +
                    "AND odiff.oldValue IS NOT NULL " +
                    "AND odiff.newValue = ' ' " +
                    "AND odiff.vistaIen = ddi.vistaIen " +
                    "AND ddi.severity.severityId = s.severityId " +           
                "ORDER BY ddi.interactionName"),
    
    @NamedQuery(name = "removePendingOutgoingDifferencesForMultipleField",
    query = "DELETE FROM EplNdfOutgoingDifferences " +
            "WHERE ndcUpdateFileFk IS NULL " +
                "AND vistaFileNumber = :vistaFileNumber " +
                "AND vistaFieldNumber like :vistaFieldNumberBase " +
                "AND vistaIen like :vistaIen"),
    
    @NamedQuery(name = "formularyDesignatorChangeReport",
    query = "SELECT odiff.newValue, p.vaProductName, p.cmopId " +
            "FROM EplNdfOutgoingDifferences odiff, EplProductDo p " +
            "WHERE odiff.ndcUpdateFileFk IS NULL " +
                "AND odiff.vistaFileNumber = :vistaFileNumber " +
                "AND odiff.vistaFieldNumber = :vistaFieldNumber " +
                "AND odiff.createdDtm <= :startDate " + 
                "AND p.ndfProductIen = odiff.vistaIen " +
                "ORDER BY p.vaProductName ")
    
    })

    
    @SqlResultSetMappings({
        @SqlResultSetMapping(name = "addedProductsReport",
            columns = { @ColumnResult(name = "newValue"),
                        @ColumnResult(name = "productName"),
                        @ColumnResult(name = "cmopId"),
                        @ColumnResult(name = "dispenseUnitName"),
                        @ColumnResult(name = "ndcNumber")
            }),
            
        @SqlResultSetMapping(name = "UnitsChangeReport",
        columns = { @ColumnResult(name = "newValue"),
                    @ColumnResult(name = "oldValue"),
                    @ColumnResult(name = "productName"),
                    @ColumnResult(name = "cmopId"),
                    @ColumnResult(name = "newName"),
                    @ColumnResult(name = "oldName")
        }),
        
        @SqlResultSetMapping(name = "ClassChangeReport",
        columns = { @ColumnResult(name = "newValue"),
                    @ColumnResult(name = "oldValue"),
                    @ColumnResult(name = "productName"),
                    @ColumnResult(name = "cmopId"),
                    @ColumnResult(name = "newClass"),
                    @ColumnResult(name = "oldClass")
        }),
        
        @SqlResultSetMapping(name = "newClassReport",
        columns = { @ColumnResult(name = "newValue"),
                    @ColumnResult(name = "productName"),
                    @ColumnResult(name = "cmopId"),
                    @ColumnResult(name = "classification"),
        }),
        
        @SqlResultSetMapping(name = "AddedDDIReport",
        columns = { @ColumnResult(name = "ddiName"),
                    @ColumnResult(name = "severityName"),
                    @ColumnResult(name = "vistaIen")                    
        }),
        
        @SqlResultSetMapping(name = "ScheduleAllChangeReport",
        columns = { @ColumnResult(name = "newValue"),
                    @ColumnResult(name = "oldValue"),
                    @ColumnResult(name = "productName"),
                    @ColumnResult(name = "cmopId"),
                    @ColumnResult(name = "newSchedule"),
                    @ColumnResult(name = "oldSchedule")
        })

    })

    @NamedNativeQueries({
        @NamedNativeQuery(name = "addedProductsReport",
            query = "SELECT odiff.new_value as newValue, p.va_product_name as productName, p.cmop_id as cmopId, du.dispense_unit_name as dispenseUnitName, ndc.ndc_number as ndcNumber " +
                    "FROM Epl_Ndf_Outgoing_Differences odiff, Epl_Products p, Epl_Va_Dispense_Units du, Epl_Ndcs ndc " +
                    "WHERE odiff.ndc_Update_File_Fk IS NULL " +
                        "AND odiff.vista_File_Number = :vistaFileNumber " +
                        "AND odiff.vista_Field_Number = :vistaFieldNumber " +
                        "AND odiff.action_Type = 'A'  " +
                        "AND odiff.created_Dtm <= :startDate " +
                        "AND odiff.vista_Ien = p.ndf_Product_Ien " +
                        "AND p.Dispense_Unit_Id_fk = du.epl_Id(+)  " +
                        "AND ndc.epl_Id_Product_fk(+) = p.epl_Id " +
                    "ORDER BY productName, cmopId, dispenseUnitName ",
            resultSetMapping="addedProductsReport"),

    @NamedNativeQuery(
            name = "newClassReport",
            query = "SELECT odiff.new_value as newValue, p.va_product_name as productName, p.cmop_id as cmopId, " +
                        "(SELECT classification_name from epl_va_drug_classes where ndf_class_ien = odiff.vista_ien) AS classification " +
                    "FROM Epl_Ndf_Outgoing_Differences odiff, Epl_Products p " +
                    "WHERE odiff.ndc_Update_File_Fk IS NULL " +
                        "AND odiff.vista_File_Number = :vistaFileNumber " +
                        "AND odiff.vista_Field_Number = :vistaFieldNumber " +
                        "AND odiff.action_Type = 'A'  " +
                        "AND odiff.created_Dtm <= :startDate " +
                        "AND odiff.vista_Ien = p.ndf_Product_Ien " +
                    "ORDER BY productName, cmopId ",
            resultSetMapping = "newClassReport"),

    @NamedNativeQuery(
        name = "drugUnitsChangeReport",
        query = "SELECT odiff.new_Value as newValue, odiff.old_Value as oldValue, p.va_product_name as productName, p.cmop_id as cmopId, " +            
                    "(SELECT name from Epl_Drug_Units where ndf_drugunit_ien = to_number(trim(odiff.new_Value))) as newName, " +
                    "(SELECT name from Epl_Drug_Units where ndf_drugunit_ien = to_number(trim(odiff.old_Value))) as oldName " +
                "FROM Epl_Ndf_Outgoing_Differences odiff, Epl_Products p, Epl_Drug_Units du " +
                "WHERE odiff.ndc_Update_File_Fk IS NULL " +
                    "AND odiff.vista_File_Number = :vistaFileNumber " +
                    "AND odiff.vista_Field_Number = :vistaFieldNumber " +
                    "AND odiff.action_Type = 'M'  " +
                    "AND odiff.created_Dtm <= :startDate " +
                    "AND odiff.old_Value <> odiff.new_Value " +
                    "AND odiff.vista_Ien = p.ndf_Product_Ien " +
                    "AND p.drug_unit_id_fk = du.epl_id(+)  " +
               "ORDER BY productName, cmopId ",
               resultSetMapping = "UnitsChangeReport"),
           
    @NamedNativeQuery(
        name = "dispenseUnitsChangeReport",
        query = "SELECT odiff.new_Value as newValue, odiff.old_Value as oldValue, p.va_product_name as productName, p.cmop_id as cmopId, " +            
                    "(SELECT dispense_unit_name from Epl_Va_Dispense_Units where ndf_dispenseunit_ien = to_number(trim(odiff.new_Value))) as newName, " +
                    "(SELECT dispense_unit_name from Epl_Va_Dispense_Units where ndf_dispenseunit_ien = to_number(trim(odiff.old_Value))) as oldName " +
                "FROM Epl_Ndf_Outgoing_Differences odiff, Epl_Products p, Epl_Va_Dispense_Units du " +
                "WHERE odiff.ndc_Update_File_Fk IS NULL " +
                    "AND odiff.vista_File_Number = :vistaFileNumber " +
                    "AND odiff.vista_Field_Number = :vistaFieldNumber " +
                    "AND odiff.action_Type = 'M'  " +
                    "AND odiff.created_Dtm <= :startDate " +
                    "AND odiff.old_Value <> odiff.new_Value " +
                    "AND odiff.vista_Ien = p.ndf_Product_Ien " +
                    "AND p.dispense_unit_id_fk = du.epl_id(+)  " +
                "ORDER BY productName, cmopId ",
        resultSetMapping = "UnitsChangeReport"),
        
    @NamedNativeQuery(
        name = "classChangeReport",
        query = "SELECT odiff.new_Value as newValue, odiff.old_Value as oldValue, p.va_product_name as productName, p.cmop_id as cmopId, " +            
                    "(SELECT code from epl_va_drug_classes where ndf_class_ien = to_number(trim(odiff.new_Value))) as newClass, " +            
                    "(SELECT code from epl_va_drug_classes where ndf_class_ien = to_number(trim(odiff.old_Value))) as oldClass " +            
                "FROM Epl_Ndf_Outgoing_Differences odiff, Epl_Products p " +
                "WHERE odiff.ndc_Update_File_Fk IS NULL " +
                    "AND odiff.vista_File_Number = :vistaFileNumber " +
                    "AND odiff.vista_Field_Number = :vistaFieldNumber " +
                    "AND odiff.action_Type = 'M'  " +
                    "AND odiff.created_Dtm <= :startDate " +
                    "AND odiff.old_Value <> odiff.new_Value " +
                    "AND odiff.vista_Ien = p.ndf_Product_Ien " +                    
               "ORDER BY productName, cmopId ",
        resultSetMapping = "ClassChangeReport"),        
        
    @NamedNativeQuery(
        name = "addedDDIReport",
        query = "SELECT odiff.new_Value as ddiName, s.name as severityName, odiff.vista_ien as vistaIen FROM epl_ndf_outgoing_differences odiff, epl_ddi_severity s " +
                "WHERE odiff.ndc_Update_File_Fk IS NULL " +                
                "AND odiff.vista_File_Number = :vistaFileNumber " +
                "AND odiff.vista_Field_Number = :vistaFieldNumber " +
                "AND odiff.action_Type = 'A'  " +
                "AND odiff.created_Dtm <= :startDate " +
                "AND s.epl_id = to_number((SELECT odiff2.new_Value FROM Epl_Ndf_Outgoing_Differences odiff2 " + 
                                            "WHERE odiff2.vista_Field_Number = '3' " + 
                                            "AND odiff2.vista_Ien = odiff.vista_Ien " +
                                            "AND odiff2.action_Type = 'A')) ",
        resultSetMapping = "AddedDDIReport"),
             
    @NamedNativeQuery(
        name = "scheduleAllChangeReport",
        query = "SELECT odiff.new_Value as newValue, odiff.old_Value as oldValue, p.va_product_name as productName, p.cmop_id as cmopId,  " +  
                    "(SELECT schedule_name from epl_cs_fed_schedules where epl_id = (select epl_id from epl_cs_fed_schedules where schedule_name like odiff.new_Value||' -%' )) as newSchedule, " +
                    "(SELECT schedule_name from epl_cs_fed_schedules where epl_id = (select epl_id from epl_cs_fed_schedules where schedule_name like odiff.old_Value||' -%' )) as oldSchedule " +
                "FROM Epl_Ndf_Outgoing_Differences odiff, Epl_Products p " +
                "WHERE odiff.ndc_Update_File_Fk IS NULL  " +
                    "AND odiff.vista_File_Number = :vistaFileNumber " +
                    "AND odiff.vista_Field_Number = :vistaFieldNumber " +
                    "AND odiff.action_Type = 'M'  " +
                    "AND odiff.created_Dtm <= :startDate " +
                    "AND odiff.old_Value <> odiff.new_Value " +
                    "AND odiff.vista_Ien = p.ndf_Product_Ien  " +
               "ORDER BY productName, cmopId ",
        resultSetMapping = "ScheduleAllChangeReport"),
        
    @NamedNativeQuery(
        name = "genericNameAllChangeReport",
        query = "SELECT odiff.new_Value as newValue, odiff.old_Value as oldValue, p.va_product_name as productName, p.cmop_id as cmopId, " +            
                    "(SELECT generic_name from epl_va_gen_names where ndf_generic_ien = to_number(trim(odiff.new_Value))) as newName, " +
                    "(SELECT generic_name from epl_va_gen_names where ndf_generic_ien = to_number(trim(odiff.old_Value))) as oldName " +
                "FROM Epl_Ndf_Outgoing_Differences odiff, Epl_Products p " +
                "WHERE odiff.ndc_Update_File_Fk IS NULL " +
                    "AND odiff.vista_File_Number = :vistaFileNumber " +
                    "AND odiff.vista_Field_Number = :vistaFieldNumber " +
                    "AND odiff.action_Type = 'M'  " +
                    "AND odiff.created_Dtm <= :startDate " +
                    "AND odiff.old_Value <> odiff.new_Value " +
                    "AND odiff.vista_Ien = p.ndf_Product_Ien " +
               "ORDER BY productName, cmopId ",
        resultSetMapping = "UnitsChangeReport"),
    
    @NamedNativeQuery(
        name = "dosageFormChangeReport",
        query = "SELECT odiff.new_Value as newValue, odiff.old_Value as oldValue, p.va_product_name as productName, p.cmop_id as cmopId, " +           
                    "(SELECT df_name from epl_dosage_forms where dosageform_ien = to_number(trim(odiff.new_Value))) as newName, " +            
                    "(SELECT df_name from epl_dosage_forms where dosageform_ien = to_number(trim(odiff.old_Value))) as oldName " +
                "FROM Epl_Ndf_Outgoing_Differences odiff, Epl_Products p " +
                "WHERE odiff.ndc_Update_File_Fk IS NULL " +
                    "AND odiff.vista_File_Number = :vistaFileNumber " +
                    "AND odiff.vista_Field_Number = :vistaFieldNumber " +
                    "AND odiff.action_Type = 'M'  " +
                    "AND odiff.created_Dtm <= :startDate " +
                    "AND odiff.old_Value <> odiff.new_Value " +
                    "AND odiff.vista_Ien = p.ndf_Product_Ien " +
               "ORDER BY productName, cmopId ",
        resultSetMapping = "UnitsChangeReport"),
        
    } )
@Table(name = "EPL_NDF_OUTGOING_DIFFERENCES"
    , schema = "PPSNEPL")
public class EplNdfOutgoingDifferences implements java.io.Serializable {

    private static final long serialVersionUID = -8735230445609556555L;
    private Long id;
    private String newValue;
    private String oldValue;
    private String vistaFileNumber;
    private String vistaFieldNumber;
    private String vistaIen;    
    private EplNdfUpdateFileDo  ndcUpdateFileFk;
    private String actionType;
    private String createdBy;
    private Date createdDtm;
    /** Action Type Add.*/
    public static final String ADD_ACTION = "A";
    /** Action Type Modify.*/
    public static final String MODIFY_ACTION = "M";
    
    /** Vista File Number Field */
    public static final String VISTA_FILE_NUMBER = "vistaFileNumber";

    /** Vista Field Number Field */
    public static final String VISTA_FIELD_NUMBER = "vistaFieldNumber";

    /** Vista IEN Field */
    public static final String VISTA_IEN = "vistaIen";

    /** Vista IEN Field */
    public static final String UPDATE_FILE_FK = "ndcUpdateFileFk";    

    public EplNdfOutgoingDifferences() {
    }

    public EplNdfOutgoingDifferences(Long id, String newValue, String oldValue, String vistaFileNumber, String vistaFieldNumber,
        String vistaIen, String actionType, String createdBy, Date createdDtm) {
        this.id = id;
        this.newValue = newValue;
        this.oldValue = oldValue;
        this.vistaFileNumber = vistaFileNumber;
        this.vistaFieldNumber = vistaFieldNumber;
        this.vistaIen = vistaIen;
        this.actionType = actionType;
        this.createdBy = createdBy;
        this.createdDtm = createdDtm;        
    }

    public EplNdfOutgoingDifferences(Long id, String newValue, String oldValue, String vistaFileNumber, String vistaFieldNumber,
        String vistaIen, EplNdfUpdateFileDo  ndcUpdateFileFk, String actionType, String createdBy, Date createdDtm) {
        this.id = id;
        this.newValue = newValue;
        this.oldValue = oldValue;
        this.vistaFileNumber = vistaFileNumber;
        this.vistaFieldNumber = vistaFieldNumber;
        this.vistaIen = vistaIen;
        this.ndcUpdateFileFk = ndcUpdateFileFk;
        this.actionType = actionType;
        this.createdBy = createdBy;
        this.createdDtm = createdDtm;        
    }

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "ndfOutgoingDifferencesSeqGen")
    @SequenceGenerator(name = "ndfOutgoingDifferencesSeqGen", sequenceName="EPL_NDF_OUTGOING_DIFFERENS_SEQ")
    @Column(name = "NDF_OUTGOING_DIFFERENCES_ID", unique = true, nullable = false, precision = 38, scale = 0)
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Column(name = "NEW_VALUE", nullable = true, length = 4000)
    public String getNewValue() {
        return this.newValue;
    }

    public void setNewValue(String newValue) {
        this.newValue = newValue;
    }
    
    @Column(name = "OLD_VALUE", nullable = true, length = 4000)
    public String getOldValue() {
        return this.oldValue;
    }

    public void setOldValue(String oldValue) {
        this.oldValue = oldValue;
    }

    @Column(name = "VISTA_FILE_NUMBER", nullable = false, length = 20)
    public String getVistaFileNumber() {
        return this.vistaFileNumber;
    }

    public void setVistaFileNumber(String vistaFileNumber) {
        this.vistaFileNumber = vistaFileNumber;
    }

    @Column(name = "VISTA_FIELD_NUMBER", nullable = false, length = 10)
    public String getVistaFieldNumber() {
        return this.vistaFieldNumber;
    }

    public void setVistaFieldNumber(String vistaFieldNumber) {
        this.vistaFieldNumber = vistaFieldNumber;
    }

    @Column(name = "VISTA_IEN", nullable = false, length = 50)
    public String getVistaIen() {
        return this.vistaIen;
    }

    public void setVistaIen(String vistaIen) {
        this.vistaIen = vistaIen;
    }

    @OneToOne
    @JoinColumn(name = "NDC_UPDATE_FILE_FK")
    public EplNdfUpdateFileDo getNdcUpdateFileFk() {
        return this.ndcUpdateFileFk;
    }

    public void setNdcUpdateFileFk(EplNdfUpdateFileDo  ndcUpdateFileFk) {
        this.ndcUpdateFileFk = ndcUpdateFileFk;
    }

    @Column(name = "ACTION_TYPE", nullable = true, length = 10)
    public String getActionType() {
        return this.actionType;
    }

    public void setActionType(String actionType) {
        this.actionType = actionType;
    }

    @Column(name = "CREATED_BY", nullable = false, length = 50)
    public String getCreatedBy() {
        return this.createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    @Column(name = "CREATED_DTM", nullable = false)
    public Date getCreatedDtm() {
        return this.createdDtm;
    }

    public void setCreatedDtm(Date createdDtm) {
        this.createdDtm = createdDtm;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return ReflectionToStringBuilder.toString(this, ToStringStyle.SHORT_PREFIX_STYLE);
    }
}
