package gov.va.med.pharmacy.peps.domain.common.model;

import java.util.Date;

/**
 * EplNdUpdateFileDo 
 * 
 * @hibernate.class
 */
public class EplNdfUpdateFileDo extends gov.va.med.pharmacy.peps.domain.common.model.DataObject implements
    java.io.Serializable{
    
 public static final String STATUS_EPL_ID = "eplStatus.statusId";
    
    private static final long serialVersionUID = 1L;

    private Long fileId;
    private String fileName;
    private String comments;   
    private String directoryPath;
    private Date testTransmissionDtm;
    private Date prodTransmissionDtm;    
    private Date statusModifiedDtm;
    private EplStatusDo eplStatus;
    
    /** default constructor */
    
    public EplNdfUpdateFileDo() {
    }

    /** minimal constructor */
    
    public EplNdfUpdateFileDo(Long fileId, String fileName, Date prodTransmissionDtm) {
        this.fileId = fileId;
        this.setFileName(fileName);
        this.setProdTransmissionDtm(prodTransmissionDtm);
    }

    /** full constructor */
    
    public EplNdfUpdateFileDo(Long fileId, String fileName, String comments, String directoryPath, Date testTransmissionDtm, 
                           Date prodTransmissionDtm, Date statusModifiedDtm, EplStatusDo eplStatus) {
        this.fileId = fileId;
        this.setFileName(fileName);
        this.setComments(comments);
        this.setDirectoryPath(directoryPath);
        this.setTestTransmissionDtm(testTransmissionDtm);
        this.setProdTransmissionDtm(prodTransmissionDtm);
        this.setStatusModifiedDtm(statusModifiedDtm);
        this.setEplStatus(eplStatus);
    }
    
    public Long getFileId() {
        return fileId;
    }
    
    public void setFileId(Long fileId) {
        this.fileId = fileId;
    }
    
    public String getFileName() {
        return fileName;
    }
    
    public void setFileName(String fileName) {
        this.fileName = fileName;
    }
    
    public String getComments() {
        return comments;
    }
    
    public void setComments(String comments) {
        this.comments = comments;
    }
    
    
    public String getDirectoryPath() {
        return directoryPath;
    }

    
    public void setDirectoryPath(String directoryPath) {
        this.directoryPath = directoryPath;
    }

    public Date getTestTransmissionDtm() {
        return testTransmissionDtm;
    }
    
    public void setTestTransmissionDtm(Date testTransmissionDtm) {
        this.testTransmissionDtm = testTransmissionDtm;
    }
    
    public Date getProdTransmissionDtm() {
        return prodTransmissionDtm;
    }
    
    public void setProdTransmissionDtm(Date prodTransmissionDtm) {
        this.prodTransmissionDtm = prodTransmissionDtm;
    }
    
    public Date getStatusModifiedDtm() {
        return statusModifiedDtm;
    }
    
    public void setStatusModifiedDtm(Date statusModifiedDtm) {
        this.statusModifiedDtm = statusModifiedDtm;
    }
    
    public EplStatusDo getEplStatus() {
        return eplStatus;
    }
    
    public void setEplStatus(EplStatusDo eplStatus) {
        this.eplStatus = eplStatus;
    }  

}
