/**
 * Source file created in 2008 by Southwest Research Institute
 */


package gov.va.med.pharmacy.peps.domain.common.utility.converter.test;


import java.util.ArrayList;
import java.util.Collection;

import gov.va.med.pharmacy.peps.common.vo.EntityType;
import gov.va.med.pharmacy.peps.common.vo.EventCategory;
import gov.va.med.pharmacy.peps.common.vo.ItemAuditHistoryVo;
import gov.va.med.pharmacy.peps.common.vo.NotificationType;
import gov.va.med.pharmacy.peps.common.vo.NotificationVo;
import gov.va.med.pharmacy.peps.domain.common.model.EplNotificationDo;
import gov.va.med.pharmacy.peps.domain.common.utility.converter.NotificationConverter;
import junit.framework.TestCase;


/**
 * Test fixture
 */
public class NotificationConverterTest extends TestCase {

    private static final EventCategory EVENT_CATEGORY = EventCategory.APPROVED_REQUEST;
    private static final EntityType ITEM_TYPE = EntityType.ORDERABLE_ITEM;
    private static final String AUDIT_HISTORY_ID = "9991";

    private EplNotificationDo dataDo;
    private NotificationVo objectVo;

    private NotificationConverter notificationConverter;

    /**
     * test setup
     * 
     * @see junit.framework.TestCase#setUp()
     */
    @Override
    public void setUp() {
        this.notificationConverter = new NotificationConverter();

        this.objectVo = createVo();
        this.dataDo = null;
    }

    /**
     * 
     * @return EplSearchTemplateDo
     */
    private NotificationVo createVo() {
        objectVo = new NotificationVo();
        objectVo.setId(AUDIT_HISTORY_ID);

        NotificationType preferenceType = NotificationType.APPROVED_NDC_ITEMS;

        objectVo.setNotificationType(preferenceType);

        Collection<ItemAuditHistoryVo> itemAudits = new ArrayList<ItemAuditHistoryVo>();
        ItemAuditHistoryVo audit = new ItemAuditHistoryVo();
        audit.setEventCategory(EVENT_CATEGORY);
        audit.setId(AUDIT_HISTORY_ID);
        audit.setAuditItemType(ITEM_TYPE);
        objectVo.setItemAudits(itemAudits);

        return objectVo;
    }

    /**
     * Test
     */
    public void testToDoHasAttributes() {
        dataDo = notificationConverter.convert(objectVo);

        assertEquals("should be equal", dataDo.getNotificationType(), objectVo.getNotificationType().name());
    }
}
