package gov.va.med.pharmacy.peps.service.common.scheduler.tasks;

import gov.va.med.pharmacy.peps.service.common.capability.FdbSchedulerProcessCapability;
import gov.va.med.pharmacy.peps.service.common.capability.RxNormUpdateCapability;

/**
 * Interface defining the method behavior for managing the RxNorm Update job process
 * 
 * @author DNS   DNS
 *
 */
public interface RxNormUpdateTask {
    
    /**
     * runRxNormUpdateProcess for RxNormUpdateTask.
     */
    void runRxNormUpdateProcess();
    
    /**
     * Gets the rxNormUpdateCapability.
     * @return the rxNormUpdateCapability
     */
    public RxNormUpdateCapability getRxNormUpdateCapability();
    
    /**
     * Sets the rxNormUpdateCapability.
     * @param rxNormUpdateCapability the rxNormUpdateCapability
     */
    public void setRxNormUpdateCapability(RxNormUpdateCapability rxNormUpdateCapability);
    
    /**
     * get FdbSchedulerProcessCapability
     * @return the fdbSchedulerProcessCapability
     */
    public FdbSchedulerProcessCapability getFdbSchedulerProcessCapability();

    /**
     * setFdbSchedulerProcessCapability
     * @param fdbSchedulerProcessCapability the fdbSchedulerProcessCapability to set
     */
    public void setFdbSchedulerProcessCapability(
            FdbSchedulerProcessCapability fdbSchedulerProcessCapability);

}
