package gov.va.med.pharmacy.peps.service.common.session.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import gov.va.med.pharmacy.peps.common.vo.RematchVo;
import gov.va.med.pharmacy.peps.common.vo.UnmatchRematchVo;
import gov.va.med.pharmacy.peps.common.vo.UserVo;
import gov.va.med.pharmacy.peps.service.common.capability.RematchCapability;
import gov.va.med.pharmacy.peps.service.common.session.RematchService;

@Service
public class RematchServiceImpl implements RematchService{
    
    @Autowired
    private RematchCapability rematchCapability;

    
    public RematchCapability getRematchCapability() {
        return rematchCapability;
    }

    
    public void setRematchCapability(RematchCapability rematchCapability) {
        this.rematchCapability = rematchCapability;
    }


    @Override
    @Transactional(readOnly=false)
    public void removeObsoleteProducts() {
        rematchCapability.removeObsoleteProducts();
        
    }
    
    @Override
    @Transactional
    public void addUnmatchedProducts(UserVo user) {
        rematchCapability.addUnmatchedProducts(user);
    }  
    
    @Override
    @Transactional
    public List<RematchVo> retrieveUnmatched(Long matchTypeId) {
        return rematchCapability.retrieveUnmatched(matchTypeId);
    }   
    
    @Override
    @Transactional
    public List<UnmatchRematchVo> findRematchProducts(Long productId) {
        return rematchCapability.findRematchProducts(productId);
    } 
    
    @Override
    @Transactional
    public void updateRematch(Long rematchId, String matchedProductIen, Boolean autoMatch) {
        rematchCapability.updateRematch(rematchId, matchedProductIen, autoMatch);
    } 

}
