package gov.va.med.pharmacy.peps.service.national.updatefile;

/**
 * Enumerates all of the message codes for messages that go in the update file reports.
 */
public enum ReportMessageCode {

  ADDEDPRODUCT,

  CMOPCHANGE,

  COPAYTIER,

  DISPENSEUNITCHANGE,

  DOSAGEFORMCHANGE,

  DRUGUNITCHANGE,

  FORMULARYDESIGNATOR,

  /**
   * The Data Update for NDF Report section header for proposed product inactivations without suggested rematches.
   */
  FUTUREINACTIVE,

  GENERICNAMECHANGE,

  INACTIVATEDCMOP,

  INACTIVATEDPRODUCT,

  INACTIVATEDREMATCHED,

  /**
   * The Data Update for NDF Report section header for immediate product inactivations with suggested rematches.
   */
  INACTIVATEDWSUGG,

  NATIONALFORMULARY,

  NEWVADRUGCLASS,

  OTHERNOREMATCH,

  OTHERREMATCHED,

  OTHERREMATCHSUGG,

  OVERRIDEDOSECHECK,

  POSSIBLEDOSAGE,

  PRINTNAMECHANGE,

  /**
   * The Data Update for NDF Report section header for proposed product inactivations with suggested rematches.
   */
  PROPOSEDINACTIVATEDWSUGG,

  REACTIVATEDPRODUCT,

  SCHEDULECHANGEALL,

  STRENGTH,

  VACLASSCHANGE,

  DDI,

  EXCLUEDEDDDI,

  MEDGUIDE,

  PREVEXCLUEDEDDDI;
  
  /**
   * Returns the actual message code, which is different from the enum name.
   * @return never null
   */
  public String getCode() {
    return "updatefile.message." + this.name();
  }
}
