package gov.va.med.pharmacy.peps.service.national.updatefile;

import static org.junit.Assert.*;

import java.util.Arrays;
import java.util.List;
import java.util.Locale;

import org.easymock.EasyMockSupport;
import org.junit.Test;
import org.springframework.context.support.StaticMessageSource;

/**
 * Unit tests for {@link UpdateFileReportGenerator}.
 */
public class UpdateFileReportGeneratorTest extends EasyMockSupport {

  @Test
  public void testFormatHeaderTextWithPadding() {
    
    /* Setup */
    
    final ReportMessageCode testCode = ReportMessageCode.CMOPCHANGE;
    final String line1 = "Header";
    final String line2 = "Message";
    
    final StaticMessageSource messageSource = new StaticMessageSource();
    messageSource.addMessage(testCode.getCode(), Locale.getDefault(), line1 + "|" + line2);
    
    final UpdateFileReportGenerator objUnderTest = new UpdateFileReportGenerator(messageSource);
    
    /* Behavior & Verification */
    
    final List<String> actualResult = objUnderTest.formatHeaderTextWithPadding(testCode);
    
    assertEquals(Arrays.asList("", line1, line2, ""), actualResult);
  }

}
