/**
 * Source file created in 2011 by Southwest Research Institute
 */


package gov.va.med.pharmacy.peps.presentation.common.pagetrail;


import java.util.Map;

import javax.servlet.http.HttpSession;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


/**
 * A {@link BeanScope} implementation that uses the current "flow" as its backing map.
 * 
 * @see PageTrail
 */
@Component
public class FlowScope extends BeanScope {

    /** session */
    @Autowired
    HttpSession session;

    @Override
    Map<String, Object> getBackingMap() {
        return (Map<String, Object>) session.getAttribute(FlowScope.class.getName());
    }

    @Override
    void setBackingMap(Map<String, Object> backingMap) {
        // Note: It would probably be better to store the backing map in the current "flow" instead of in the Session
        // directly. (See class doc comment.)
        session.setAttribute(FlowScope.class.getName(), backingMap);
    }
}
