<%@ taglib prefix="tiles" uri="http://tiles.apache.org/tags-tiles"%>
<%@ taglib prefix="peps" tagdir="/WEB-INF/tags"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>

<peps:warnings id="warnings" warnings="${warnings}"/>
<form:form id="unmatchedProductsRematch" name="unmatchedProductsRematch"
	modelAttribute="editRematchBean" action="createRematch.go" method="post"
	onsubmit="return disableSubmit(this.id);">

	<div class="body-content">

		<div class="horizontalspacer"></div>
		<table border="0" width="100%" cellpadding="0" cellspacing="0">

			<tr>
				<td style="vertical-align: top">
					<div style="overflow: auto; height: 400px; width: 680px;">
						<table border="1" style="width: 670px;" cellspacing="0" class="rematchTable">
							<thead>
								<tr>
									<th colspan="4" align="center">
										<h1 style="font-size: medium" align="center">Modified
											Product</h1>
									</th>
								</tr>
								<tr>
									<th align="center" width="100px">VA Product Name</th>
									<th align="center" width="50px">VA Product ID</th>
								</tr>
							</thead>

							<tr class="${status.index % 2 == 0 ? 'even' : 'odd'}">
								<c:choose>
									<c:when test="${editRematchBean.unmatchedProduct.productName == null}">
										<td align="center" valign="middle"><peps:text
												item="${editRematchBean.unmatchedProduct}" key="va.product.name"
												value="" /></td>
									</c:when>
									<c:otherwise>
										<td align="center" valign="middle"><peps:text
												item="${editRematchBean.unmatchedProduct}" key="va.product.name"
												value="${editRematchBean.unmatchedProduct.productName}" /></td>
									</c:otherwise>
								</c:choose>
								<c:choose>
									<c:when test="${editRematchBean.unmatchedProduct.cmop == null}">
										<td align="center" valign="middle"><peps:text
												item="${editRematchBean.unmatchedProduct}" key="cmop.id" value="" /></td>
									</c:when>
									<c:otherwise>
										<td align="center" valign="middle"><peps:text
												item="${editRematchBean.unmatchedProduct}" key="cmop.id"
												value="${editRematchBean.unmatchedProduct.cmop}" /></td>
									</c:otherwise>
								</c:choose>
							</tr>
							<tr>
								<td>
								    <input type="hidden" value="${editRematchBean.unmatchedProduct.id}" 
								    name="tableId" /> 
								</td>
							</tr>
						</table>
					</div>
				</td>
				<td style="vertical-align: top; align: top;">

					<table border="1" style="width: 565px;" cellspacing="0" class="rematchTable" >
						<thead>
							<tr>
								<th colspan="5" align="center">
									<h1 style="font-size: medium" align="center">Possible Matches</h1>
								</th>
							</tr>
							<tr>
								<th align="center">VA Product Name</th>
								<th align="center">VA Product ID</th>
								<th align="center">Status</th>
								<th align="center">Suggestion</th>
								<th align="center">Automatic</th>
							</tr>
						</thead>
						<c:choose>
							<c:when test="${empty editRematchBean.potentialMatches}">
								<tr>
									<td colspan="5"><font size="4" color="maroon"><b>No
												Results Found</b></font></td>
								</tr>
							</c:when>
							<c:otherwise>
								<c:forEach var="productMatch"
									items="${editRematchBean.potentialMatches}" begin="0" varStatus="prod">
									<tr class="${prod.index % 2 == 0 ? 'even' : 'odd'}">
										<c:choose>
											<c:when test="${productMatch.matchedProductName == null}">
												<td align="center"><peps:text
														item="${productMatch}" key="va.product.name" value="" /></td>
											</c:when>
											<c:otherwise>
												<td align="center"><peps:text
														item="${productMatch}" key="va.product.name"
														value="${productMatch.matchedProductName}" /></td>
											</c:otherwise>
										</c:choose>
										<c:choose>
											<c:when test="${productMatch.matchedCmop == null}">
												<td align="center"><peps:text
														item="${productMatch}" key="cmop.id" value="" /></td>
											</c:when>
											<c:otherwise>
												<td align="center"><peps:text
														item="${productMatch}" key="cmop.id"
														value="${productMatch.matchedCmop}" /></td>
											</c:otherwise>
										</c:choose>
										<!--
										All products returned right now are active, but the database query doesn't
										return this. If we ever support inactive products, we will have to change this.
										All automatic rematch items are Active the status manualy added items can be Inactive.
										-->
                                        <c:choose>
                                            <c:when test="${productMatch.itemStatus == null}">
                                                <td align="center"><peps:text
                                                    item="${productMatch}" key="item.status" value="" /></td>
                                             </c:when>
                                             <c:otherwise>
                                                    <td align="center"><peps:text
                                                        item="${productMatch}" key="item.status"
                                                                    value="${productMatch.itemStatus}" /></td>
                                                    </c:otherwise>
                                         </c:choose>
										<td align="center">
										    <form:checkbox
												value="${productMatch.matchedProductId}"
												path="toSuggestedProductIdSet" />
										</td>
										<td align="center">
											<form:radiobutton
												value="${productMatch.matchedProductId}"
												path="toAutoProductId" />
										</td>
									</tr>
								</c:forEach>
							</c:otherwise>
						</c:choose>
					</table>
				</td>
			</tr>
		</table>
		
	<!-- buttons panel -->	
        <div class="panel">
            <div class="floatRight">
	            <span class="column"><peps:submit key="button.cancel" action="cancelRematch.go" /></span>         
	            <span class="column">
	                <button type="button" onclick="window.location.href='associateProductToRematch.go'">Search</button>          
	            </span>       
	            <span class="column">
	                 <button type="button" onclick="window.location.href='modificationSummary.go'">Skip</button>            
	            </span>
	            <span class="column">
	               <input type="submit" value="Submit"/>           
	            </span>          
            </div>
         </div>
    <!-- buttons panel end -->  
	</div>
</form:form>

<script src="/PRE/javascript/rematch.js" type="text/javascript"></script>